package objetosAuxilidares;

import util.Point;
import util.Vetor;

//Triangulo
public final class ElementoTriangulo extends Elemento {
	
	private Triangulo geom;	
	
	public ElementoTriangulo(Triangulo geom,Material m) {
		super(m);
		this.geom = geom;
	}
	
	public Triangulo getGeometry(){
		return this.geom;
	}	

	@Override
	public boolean isGeometric() {
		return true; //eh um triangulo
	}
	
	@Override
	public boolean isQuadric() {
		return false;
	}

	@Override
	public Point getIntersec(Ray ray) {		
		return geom.getIntersection(ray);
	}

	@Override
	public Vetor calcularNormal(final Point p, Ray ray) {	
		return geom.econtrarNormal(p, ray);
		
	}

}
