package objetosAuxilidares;
import util.Point;
import util.Quadric;
import util.Vetor;

public class Quadricas extends Elemento {
	private CoeficendesDasQuadricas coef;			//Gives the coefficients of the quadric	
	
	public Quadricas(CoeficendesDasQuadricas coef,Material m) {
		super(m);
		this.coef = coef;
	}
	
	public CoeficendesDasQuadricas getCoef() {
		return coef;
	}

	@Override
	public boolean isGeometric() {
		return false;
	}
	
	@Override
	public boolean isQuadric() {
		return true;
	}

	@Override
	public Point getIntersec(Ray ray) {
		final double dist = Quadric.intersect(ray,coef);
		if(dist <= 0)
			return null;
		Vetor v = new Vetor(ray.getOrig(),ray.getDir());
		v.normalize();
		v.svmpy(dist);
		Point result = new Point(ray.getOrig());
		result.add(v);
		return result;
	}

	@Override
	public Vetor calcularNormal(Point p, Ray ray) {
		Vetor result = coef.getNormal(p);
		result.normalize();
		return result;
	}
	
}
