package objetosAuxilidares;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Random;

import util.Face;
import util.Point;
import util.Vetor;



public class Triangulo {
	
	private List<Point> points;	//Colecao dos pontos do objeto
	private List<Face> faces;		//Indexes of the points that compose the faces in the object geometry
	
	//Constructor
	public Triangulo(List<Point> points, List<Face> faces){
		this.points = points;
		this.faces = faces;		
	}
	
	
	public Point getPointAt(int i){
		return this.points.get(i);
	}
	
	
	public void addPoint(Point p){
		this.points.add(p);
	}
	
	
	public Face getFaceAt(int i){
		return this.faces.get(i);
	}

	public void addFace(Face f){
		this.faces.add(f);
	}
	
	public Vetor econtrarNormal(final Point p, Ray ray) {
		for(Face face : faces){
			return face.calcularNormal(p,ray);
		}
		System.out.println("nao achou a normal do ponto: "+p);
		return null;
	}
	
	public List<Point> getBoundingPlusBarycenterPoints(){
		
		List<Point> result = new ArrayList<Point>();
		/*Random r = new Random();
		for(int i = 0; i < 100; i++){			
			int index = r.nextInt(faces.size());
			Face f = faces.get(index);
			result.add(f.getRandom());
		}*/
		
		
		
		/*
		 * Point pResult = new Point(0,0,0);
		 * for(Point p : result){
			pResult.setX(pResult.getX() + p.getX());
			pResult.setY(pResult.getY() + p.getY());
			pResult.setZ(pResult.getZ() + p.getZ());
		}
		pResult.setX(pResult.getX() / result.size());
		pResult.setY(pResult.getY() / result.size());
		pResult.setZ(pResult.getZ() / result.size());*/
		
		result.addAll(points);
		for(Face face : faces){
			result.add(face.getBaricentro());			
		}
		
		return result;
	}
	
	public Iterator<Face> getFacesIt(){
		return this.faces.iterator();
	}
	
	public Point getIntersection(final Ray ray){		
		for(Face face : faces){
			final Point p = face.getInterseccao(ray);
			if(p != null)
				return p;
		}
		return null;		
	}

	public Face getFace(final Ray ray) {
		for(Face face : faces){			
			if(face.getInterseccao(ray) != null){
				return face;
			}
		}
		return null;
	}
	
	public List<Triangulo> getObjects(){
		List<Triangulo> result = new ArrayList<Triangulo>();
		for(Face f: faces){
			List<Point> points = new ArrayList<Point>(this.points);	
			List<Face> faces = new ArrayList<Face>();
			faces.add(f);
			result.add(new Triangulo(points,faces));
		}		
		return result;
	}
	public Point getAleatoryPointInner(){
		Point auxReturn = null;
		Random rd = new Random();
		int numFaces = this.faces.size();
		Face face = this.faces.get(rd.nextInt(numFaces));
		Point v1 = face.getV1();
		Point v2 = face.getV2();
		Point v3 = face.getV3();
		
		Vetor vec1 = new Vetor(v1, v2);
		Vetor vec2 = new Vetor(v2, v3);
		double scalar = rd.nextDouble();
		vec2.svmpy(scalar);
		vec1.add(vec2);
		scalar = rd.nextDouble();
		vec1.svmpy(scalar);
		vec1.add(new Vetor(v1));
		
		auxReturn =new Point(vec1.getX(), vec1.getY(), vec1.getZ());
		
		//Random rand = new Random(3);
		return auxReturn;
	}
}