package util;

import objetosAuxilidares.CoeficendesDasQuadricas;
import objetosAuxilidares.Ray;


public class Quadric {
	

	
	public static double intersect(Ray ray, CoeficendesDasQuadricas coefficients) {
		
		double a, b, c, d, e;			
		double f, g, h, j, k;			
		double acoef, bcoef, ccoef;		
		double dx, dy, dz; 			
		double disc;					
		double root;					
		double t;						
		double x0, y0, z0;				
		
		a = coefficients.getA();
		b = coefficients.getB();
		c = coefficients.getC();
		d = coefficients.getD();
		e = coefficients.getE();
		f = coefficients.getF();
		g = coefficients.getG();
		h = coefficients.getH();
		j = coefficients.getJ();
		k = coefficients.getK();
		
		x0 = ray.getOrig().getX();
		y0 = ray.getOrig().getY();
		z0 = ray.getOrig().getZ();
		
		dx = ray.getDir().getX() - x0;
		dy = ray.getDir().getY() - y0;
		dz = ray.getDir().getZ() - z0;
		
		acoef = 2 * f * dx * dz + 2 * e * dy * dz + c * dz * dz + b * dy * dy +
			a * dx * dx + 2 * d * dx * dy;
		
		bcoef = 2 * b * y0 * dy + 2 * a * x0 * dx + 2 * c * z0 * dz +
			2 * h * dy + 2 * g * dx + 2 * j * dz + 2 * d * x0 * dy +
			2 * e * y0 * dz + 2 * e * z0 * dy + 2 * d * y0 * dx +
			2 * f * x0 * dz + 2 * f * z0 * dx;
		
		ccoef = a * x0 * x0 + 2 * g * x0 + 2 * f * x0 * z0 + b * y0 * y0 +
			2 * e * y0 * z0 + 2 * d * x0 * y0 + c * z0 * z0 + 2 * h * y0 +
			2 * j * z0 + k;
		
		
		/*
		 
		  if(1.0 + acoef == 1.0){
			if(1.0 + bcoef == 1.0){
				return -1.0;
			}
			t = (-ccoef) / (bcoef);
		}else{
			disc = bcoef * bcoef - 4 * acoef * ccoef;
			if(1.0 + disc < 1.0){
				return -1.0;
			}
			root = Math.sqrt(disc);
			t = (-bcoef - root)/(acoef + acoef);
			if(t < 0.0){
				t = (-bcoef + root) / (acoef + acoef);
			}
		}
		 
		 */
		if(1.0 + acoef == 1.0){
			if(1.0 + bcoef == 1.0){
				return -1.0;
			}
			t = (-ccoef) / (bcoef);
		}else{
			disc = bcoef * bcoef - 4 * acoef * ccoef;
			if(1.0 + disc < 1.0){
				return -1.0;
			}
			root = Math.sqrt(disc);
			t = (-bcoef - root)/(acoef + acoef);
			if(t < 0.0){
				t = (-bcoef + root) / (acoef + acoef);
			}
		}
		
		if(t < 0.001){
			return -1.0;
		}
		return t;
	}						
}