/*
 * Created on 05/03/2008
 */
package numerics;

/**
 * @author Marlus Barbosa de Souza - mbs2
 * @author Artur Lira dos Santos - als3
 */
public class Point {
	
	private double x;	//Coordenada x do ponto
	private double y;	//Coordenada y do ponto.
	private double z;	//Coordenada z do ponto.
	
	//Construtor
	public Point(double x, double y, double z){
		this.x = x;
		this.y = y;
		this.z = z;
	}
	
	public Point(final Point p){
		this.x = p.x;
		this.y = p.y;
		this.z = p.z;
	}

	//Getters e Setters
	public double getX(){
		return this.x;
	}
	public void setX(double x){
		this.x = x;
	}
	public double getY(){
		return this.y;
	}
	public void setY(double y){
		this.y = y;
	}
	public double getZ(){
		return this.z;
	}
	public void setZ(double z){
		this.z = z;
	}
	
	public void add(final Vec v){
		this.x += v.getX();
		this.y += v.getY();
		this.z += v.getZ();
	}
	
	public Point getAddition(final Vec v){
		Point result = new Point(this);
		result.add(v);
		return result;
	}
	
	public String toString() {
		return "(" + this.x + "," + this.y + "," + this.z + ")";
	}	
}