/*
 * Created on 08/03/2008
 */
package objectDefinitions.Element;

import numerics.Point;
import numerics.Vec;
import objectDefinitions.Mat;
import objectDefinitions.Ray;

/**
 * @author Marlus Barbosa de Souza - mbs2
 * @author Artur Lira dos Santos - als3
 */
//Class that represents any element in the scene.
public abstract class Element {
	
	protected Mat m;					//The element surface material properties
	
	//Constructor
	public Element(Mat m){
		this.m = m;
	}
	
	public Mat getM() {
		return m;
	}

	public void setM(Mat m) {
		this.m = m;
	}
	
	public abstract Point getIntersection(final Ray ray);
	
	public abstract Vec findNormal(final Point p);
	
	public abstract boolean isQuadric();
	public abstract boolean isGeometric();	

}