package objectDefinitions.Element;

import numerics.Point;
import numerics.Vec;
import objectDefinitions.Mat;
import objectDefinitions.ObjectGeometry;
import objectDefinitions.Ray;

public final class GeometricElement extends Element {
	
	private ObjectGeometry geom;	//Gives the triangular geometry of the object
	
	public GeometricElement(ObjectGeometry geom,Mat m) {
		super(m);
		this.geom = geom;
	}
	
	public ObjectGeometry getGeometry(){
		return this.geom;
	}	

	@Override
	public boolean isGeometric() {
		return true;
	}
	
	@Override
	public boolean isQuadric() {
		return false;
	}

	@Override
	public Point getIntersection(Ray ray) {		
		return geom.getIntersection(ray);
	}

	@Override
	public Vec findNormal(final Point p) {	
		return geom.findNormal(p);
		
	}

}
