/*
 * Created on 05/03/2008
 */
package objectDefinitions;

/**
 * @author Marlus Barbosa de Souza- mbs2
 * @author Artur Lira dos Santos - als3
 */

//From quadric.h -> Prototypes for quadric.cpp

//Material structure
public class Mat{
	
	private double r;		//Red color component
	private double g;		//Green color component
	private double b;		//Blue color component
	private double Ka;		//Ambient reflection coefficent
	private double Kd;		//Diffuse reflection coefficent
	private double Ks;		//Specular reflection coefficent
	private int n;			//Specular reflection exponent
	private double KT;		//Global material refraction (transmission) constant
	private double ir;		//Refraction index of the material
	
	//Material constructor
	public Mat(double r, double g, double b, double Ka, double Kd,
			double Ks, double KT, int n, double ir) {
		this.r = r;
		this.g = g;
		this.b = b;
		this.Ka = Ka;
		this.Kd = Kd;
		this.Ks = Ks;
		this.KT = KT;
		this.n = n;
		this.ir = ir;
	}
	
	//Getters and setters
	public double getR() {
		return this.r;
	}
	public void setR(double arg0) {
		this.r = arg0;
	}
	public double getG() {
		return this.g;
	}
	public void setG(double arg0) {
		this.g = arg0;
	}
	public double getB() {
		return this.b;
	}
	public void setB(double arg0) {
		this.b = arg0;
	}
	public double getKa() {
		return this.Ka;
	}
	public void setKa(double arg0) {
		this.Ka = arg0;
	}
	public double getKd() {
		return this.Kd;
	}
	public void setKd(double arg0) {
		this.Kd = arg0;
	}
	public double getKs() {
		return this.Ks;
	}
	public void setKs(double arg0) {
		this.Ks = arg0;
	}
	public int getN() {
		return this.n;
	}
	public void setN(int arg0) {
		this.n = arg0;
	}
	public double getKT() {
		return this.KT;
	}
	public void setKT(double arg0) {
		this.KT = arg0;
	}
	public double getIr() {
		return this.ir;
	}
	public void setIr(double arg0) {
		this.ir = arg0;
	}
}