/*
 * Created on 05/03/2008
 */
package objectDefinitions;

import numerics.Point;
import numerics.Vec;
/**
 * @author Marlus Barbosa de Souza - mbs2
 * @author Artur Lira dos Santos - als3
 */

//From quadric.h -> Prototypes for quadric.cpp

//Quadric surface structure coefficients
public class QuadCoef{
	
	//Surface coefficents
	private double a;
	private double b;
	private double c;
	private double d;
	private double e;
	private double f;
	private double g;
	private double h;
	private double j;
	private double k;
	
	public QuadCoef(double arg0, double arg1, double arg2, double arg3, double arg4,
			double arg5, double arg6, double arg7, double arg8, double arg9){
		this.a = arg0;
		this.b = arg1;
		this.c = arg2;
		this.d = arg3;
		this.e = arg4;
		this.f = arg5;
		this.g = arg6;
		this.h = arg7;
		this.j = arg8;
		this.k = arg9;
	}
	
	//Getters and setters
	public double getA() {
		return this.a;
	}
	public void setA(double arg0) {
		this.a = arg0;
	}
	public double getB() {
		return this.b;
	}
	public void setB(double arg0) {
		this.b = arg0;
	}
	public double getC() {
		return this.c;
	}
	public void setC(double arg0) {
		this.c = arg0;
	}
	public double getD() {
		return this.d;
	}
	public void setD(double arg0) {
		this.d = arg0;
	}
	public double getE() {
		return this.e;
	}
	public void setE(double arg0) {
		this.e = arg0;
	}
	public double getF() {
		return this.f;
	}
	public void setF(double arg0) {
		this.f = arg0;
	}
	public double getG() {
		return this.g;
	}
	public void setG(double arg0) {
		this.g = arg0;
	}
	public double getH() {
		return this.h;
	}
	public void setH(double arg0) {
		this.h = arg0;
	}
	public double getJ() {
		return this.j;
	}
	public void setJ(double arg0) {
		this.j = arg0;
	}
	public double getK() {
		return this.k;
	}
	public void setK(double arg0) {
		this.k = arg0;
	}
	
	//Rotina que calcula a normal da qudrica no ponto especificado
	//atravs do clculo da derivada da equao da superfcie no ponto
	public Vec getNormal(Point ponto) {
		double x = 2*this.a*ponto.getX() + 2*this.d*ponto.getY() + 2*this.f*ponto.getZ() + 2*this.g;
		double y = 2*this.b*ponto.getY() + 2*this.d*ponto.getX() + 2*this.e*ponto.getZ() + 2*this.h;
		double z = 2*this.c*ponto.getZ() + 2*this.e*ponto.getY() + 2*this.f*ponto.getX() + 2*this.j;
		Vec ret = new Vec(x, y, z);
		return ret;
	}
}