/*
 * Created on 05/03/2008
 */
package objectDefinitions;

import numerics.Face;
import numerics.Numerics;
import numerics.Point;


/**
 * @author Marlus Barbosa de Souza - mbs2
 * @author Artur Lira dos Santos - als3
 */

//From quadric.h -> Prototypes for quadric.cpp

//Ray structure
public class Ray {
	
	private Point orig;		//Origin of ray
	private Point dir;		//Point of Direction of ray
		
	//Ray constructor
	public Ray(Point orig, Point dir) {
		this.orig = orig;
		this.dir = dir;
	}
	
	public Ray(final Ray r){
		this.orig = new Point(r.getOrig());
		this.dir = new Point(r.getDir());
	}
	//Getters and setters
	public Point getOrig() {
		return this.orig;
	}
	public void setOrig(Point arg0) {
		this.orig = arg0;
	}
	public Point getDir() {
		return this.dir;
	}
	public void setDir(Point arg0) {
		this.dir = arg0;
	}
	
	public Point getIntersectionPoint(final Face face, final float tolerance){
		return face.getIntersectionPoint(this);
	}
	
	public boolean isZero(final double tolerance){
		return Numerics.equals(orig.getX() - dir.getX(),0,tolerance) && Numerics.equals(orig.getY() - dir.getY(),0,tolerance) && Numerics.equals(orig.getZ() - dir.getZ(),0,tolerance) ;
	}
	
	
}