/*
 * Created on 05/03/2008
 */
package sceneDefinitions;

/**
 * @author Marlus Barbosa de Souza - mbs2
 * @author Artur Lira dos Santos - als3
 */

//Classe que armazena as informaes de cor
public class Color {
	
	private double r;		//Valor da intensidade da componente vermelha
	private double g;		//Valor da intensidade da componente verde
	private double b;		//Valor da intensidade da componente azul
	
	//Construtor para a classe color
	public Color(double arg0, double arg1, double arg2){
		this.r = arg0;
		this.g = arg1;
		this.b = arg2;
	}
	
	public Color(final Color c){
		this.r = c.r;
		this.g = c.g;
		this.b = c.b;
	}
	
	//Getters and setters
	public double getR(){
		return this.r;
	}
	public void setR(double arg0){
		this.r = arg0;
	}
	public double getG(){
		return this.g;
	}
	public void setG(double arg0){
		this.g = arg0;
	}
	public double getB(){
		return this.b;
	}
	public void setB(double arg0){
		this.b = arg0;
	}
	
	//Funo para somar esta cor quela passada como parmetro
	public void add(Color c){
		this.r += c.r;
		this.g += c.g;
		this.b += c.b;
	}
	
	public void add(final double k){
		this.r += k;
		this.g += k;
		this.b += k;
	}
	
	public void multiply(Color c){
		this.r *= c.r;
		this.g *= c.g;
		this.b *= c.b;
	}
	
	public void multiply(final double k){
		this.r *= k;
		this.g *= k;
		this.b *= k;
	}
	
	public void divide(Color c){
		this.r /= c.r;
		this.g /= c.g;
		this.b /= c.b;
	}
	
	public void divide(final double k){
		this.r /= k;
		this.g /= k;
		this.b /= k;
	}
	
	
	public Color getAddition(final Color c){
		Color result = new Color(this);
		result.add(c);
		return result;	
	}
	
	public Color getAddition(final double k){
		Color result = new Color(this);
		result.add(k);
		return result;	
	}
	
	public Color getProduct(final Color c){
		Color result = new Color(this);
		result.multiply(c);
		return result;	
	}
	
	public Color getProduct(final double k){
		Color result = new Color(this);
		result.multiply(k);
		return result;	
	}
	
	public Color getQuotient(final Color c){
		Color result = new Color(this);
		result.divide(c);
		return result;	
	}
	
	public void ceil(final double ceil){
		if(r > ceil)
			r = ceil;
		if(g > ceil)
			g = ceil;
		if(b > ceil)
			b = ceil;
	}
	
	public void fit(){
		final double ceil = 1;
		if(r > ceil)
			r = ceil;
		if(g > ceil)
			g = ceil;
		if(b > ceil)
			b = ceil;
		
		if(r < 0)
			r = 0;
		if(g < 0)
			g = 0;
		if(b < 0)
			b = 0;		
	}
	
	//Funo que multiplica os valores da cor por uma constante
	//public void multColor(double arg0){
	//	this.r = this.r * arg0;
	//	this.g = this.g * arg0;
	//	this.b = this.b * arg0;
	//}
	
	//Funo que transforma a cor numa string pronta para ser escrita no arquivo
	//PNM
	public String toString(double arg0) {
		double R = this.r;
		R = R * arg0;
		double G = this.g;
		G = G * arg0;
		double B = this.b;
		B = B * arg0;
		return (int) R + " " + (int) G + " " + (int) B;
	}
}