/*
 * Created on 05/03/2008
 */
package sceneDefinitions;

/**
 * @author Marlus Barbosa de Souza - mbs2
 * @author Artur Lira dos Santos - als3
 */

//Classe que representa a tela, como uma matriz (array bi-dimensional) dividida
//pelas unidades de largura e altura passadas como parmetro
public class Screen {
	
	//private int w;				//A largura da tela
	//private int h;				//A altura da tela
	private Color[][] screen;	//A matriz onde sero armazenadas as cores
	private Coord2d zero;		//A coordenada inferior esquerda da tela
	private Coord2d one;		//A coordenada superior direita da tela
		
	//Construtor da classe tela que inicializa os atributos como vazios
	public Screen() {
		this.screen = null;
		this.zero = null;
		this.one = null;
	}

	public int getWidth() {
		return this.screen[0].length;
	}
	
	public int getHeight() {
		return this.screen.length;
	}
	
	public Color getColorAt(int i, int j) {
		return this.screen[i][j];
	}
	public void setColorAt(Color color, int i, int j) {
		this.screen[i][j] = color;		
	}
	
	public Coord2d getZero() {
		return this.zero;
	}
	public void setZero(Coord2d zero) {
		this.zero = zero;		
	}
	
	public Coord2d getOne() {
		return this.one;
	}
	public void setOne(Coord2d one) {
		this.one = one;		
	}
	
	//Funo que inicializa o array, desde que a altura e largura ja tenham 
	//sido definidas
	public void initArray(final int width, final int height) {
		this.screen = new Color[height][width];
	}	
}